import javax.media.opengl.GL;

public class Camera
{
    protected Projection cameraProjection;
    protected CameraStyle cameraStyle;
    protected Viewport cameraViewport;
    protected double eyex;
    protected double eyey;
    protected double eyez;
    protected double centerx;
    protected double centery;
    protected double centerz;

    Camera(Projection projection)
    {
	this.cameraProjection = projection;
    }

    public void setProjection(Projection projection)
    {
	this.cameraProjection = projection;
    }

    public Projection getProjection()
    {
	return this.cameraProjection;
    }

    public void setCameraStyle(CameraStyle cameraStyle)
    {
	this.cameraStyle = cameraStyle;
    }

    public CameraStyle getCameraStyle()
    {
	return this.cameraStyle;
    }

    public void setViewport(Viewport viewport)
    {
	this.cameraViewport = viewport;
    }

    public Viewport getViewport()
    {
	return this.cameraViewport;
    }

    public void apply()
    {
	final GL gl = Renderer.GL;

	if (gl != null)
	{
	    gl.glViewport(this.cameraViewport.x, this.cameraViewport.y,
			  this.cameraViewport.width, this.cameraViewport.height);

	    this.cameraProjection.apply();
	}
    }

    public void translate(float x, float y, float z)
    {
	this.cameraStyle.translate(x, y, z);
    }

    public void rotate(float x, float y, float z)
    {
	this.cameraStyle.rotate(x, y, z);
    }

    public void lookAt(double eyex, double eyey, double eyez, double centerx, double centery, double centerz)
    {
	this.eyex = eyex;
	this.eyey = eyey;
	this.eyez = eyez;
	this.centerx = centerx;
	this.centery = centery;
	this.centerz = centerz;
    }

    public void lookAt()
    {
	Renderer.GLU.gluLookAt(eyex,eyey,eyez,centerx,centery,centerz,0.0,1.0,0.0);
    }
}
