import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

public abstract class Renderer
{
    protected static GL GL = null;
    protected static GLU GLU = null;

    protected Camera camera;
 
    Renderer()
    {
	Projection theProjection = new Orthographic(-1.0f, 1.0f, -1.0f, 1.0f, -1.0f, 1.0f);
	this.camera = new Camera(theProjection);
    }

    /* Abstract methods */
    public abstract void present(GridWorld world);

    /* Static Methods */
    public static void setGL(GL gl)
    {
	GL = gl;
    }

    public static void setGLU(GLU glu)
    {
	GLU = glu;
    }

    public Camera getCamera()
    {
	return this.camera;
    }
}
